# Generated by Django 5.1.8 on 2025-05-16 09:08

import django.db.models.deletion
import taggit.managers
import utilities.json
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('dcim', '0200_populate_mac_addresses'),
        ('extras', '0123_journalentry_kind_default'),
        ('tenancy', '0017_natural_ordering'),
        ('virtualization', '0048_populate_mac_addresses'),
    ]

    operations = [
        migrations.CreateModel(
            name='ClusterAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('cluster', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='cluster_assignments', to='virtualization.cluster')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ClusterGroupAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('cluster_group', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='cluster_group_assignments', to='virtualization.clustergroup')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DeviceAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('device', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='device_assignments', to='dcim.device')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='InstalledApplication',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('status', models.CharField(max_length=50)),
                ('status_date', models.DateField(null=True)),
                ('comments', models.TextField(blank=True)),
                ('name', models.CharField(max_length=150)),
                ('description', models.CharField(blank=True, max_length=500)),
                ('version', models.CharField(max_length=200)),
                ('url', models.URLField(max_length=300)),
                ('cluster', models.ManyToManyField(related_name='installedapplication', through='adestis_netbox_applications.ClusterAssignment', to='virtualization.cluster')),
                ('cluster_group', models.ManyToManyField(related_name='installedapplication', through='adestis_netbox_applications.ClusterGroupAssignment', to='virtualization.clustergroup')),
                ('device', models.ManyToManyField(related_name='installedapplication', through='adestis_netbox_applications.DeviceAssignment', to='dcim.device')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='applications_tenant', to='tenancy.tenant')),
                ('tenant_group', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='applications_tenant_group', to='tenancy.tenantgroup')),
            ],
            options={
                'verbose_name': 'Application',
                'verbose_name_plural': 'Applications',
            },
        ),
        migrations.AddField(
            model_name='deviceassignment',
            name='installed_application',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_applications.installedapplication'),
        ),
        migrations.AddField(
            model_name='clustergroupassignment',
            name='installed_application',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_applications.installedapplication'),
        ),
        migrations.AddField(
            model_name='clusterassignment',
            name='installed_application',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_applications.installedapplication'),
        ),
        migrations.CreateModel(
            name='Software',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('status', models.CharField(max_length=50)),
                ('name', models.CharField(max_length=150)),
                ('description', models.CharField(blank=True, max_length=500)),
                ('url', models.URLField(max_length=300)),
                ('manufacturer', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='applications_manufacturer', to='dcim.manufacturer')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'verbose_name': 'Software',
                'verbose_name_plural': 'Softwares',
            },
        ),
        migrations.AddField(
            model_name='installedapplication',
            name='software',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='applications_software', to='adestis_netbox_applications.software'),
        ),
        migrations.CreateModel(
            name='VirtualMachineAssignment',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('installed_application', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='adestis_netbox_applications.installedapplication')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
                ('virtual_machine', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='virtual_machine_assignments', to='virtualization.virtualmachine')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='installedapplication',
            name='virtual_machine',
            field=models.ManyToManyField(related_name='installedapplication', through='adestis_netbox_applications.VirtualMachineAssignment', to='virtualization.virtualmachine'),
        ),
    ]
